---


- name: Install yum repo
  template:
      src: "{{ item.src }}"
      dest: "{{ item.dest }}"
      backup: yes
  with_items:
    - src: "mssql-server-preview.repo"
      dest: /etc/yum.repos.d/mssql-server-preview.repo
    - src: "msprod.repo"
      dest: /etc/yum.repos.d/msprod.repo

- name: Remove older unixODBC files if performing upgrade
  yum:
      name: "{{ unixODBC_packages }}"
      state: absent

- name: Install packages
  yum:
      name: "{{ mssql_package }}"
      state: present

- name: Export UTF-8 encoding for mssql-cli-tool
  shell: export LC_ALL=en_US.UTF-8

- name: Install mssql-cli-tool via command with args
  shell: ACCEPT_EULA=Y yum install mssql-tools -y

- name: Add mssql tools to .bashrc
  lineinfile:
      dest: "{{ ansible_user_dir}}/.bashrc"
      state: present
      line: 'export PATH="$PATH:/opt/mssql-tools/bin"'

- name: Get iptables rules
  shell: iptables -L
  register: iptablesrules
  changed_when: False
  when: mssql_fw_rules

# - name: Apply iptables rule for MSSQL port 1433
#   iptables:
#       chain: INPUT
#       protocol: tcp
#       destination_port: 1433
#       jump: ACCEPT_TRUSTED
#       comment: ansible_mssql_1433_
#   when: (mssql_fw_rules and iptablesrules.stdout.find("ansible_mssql_1433_") == -1) or (mssql_fw_rules and iptablesrules.stdout.find("ansible_mssql_5022_") == -1)
#   notify: save iptables

- name: Apply iptables rule for MSSQL port 5022
  iptables:
      chain: INPUT
      protocol: tcp
      destination_port: "{{ item.destination_port }}"
      jump: ACCEPT_TRUSTED
      comment: "{{ item.comment }}"
  when: (mssql_fw_rules and iptablesrules.stdout.find("ansible_mssql_1433_") == -1) and (mssql_fw_rules and iptablesrules.stdout.find("ansible_mssql_5022_") == -1)
  with_items:
    - destination_port: 5022
      comment: ansible_mssql_5022_
    - destination_port: 1433
      comment: ansible_mssql_1433_
  notify: save iptables

- name: Apply iptables rule for pacemaker
  iptables:
      chain: INPUT
      protocol: "{{ item.protocol }}"
      destination_port: "{{ item.destination_port }}"
      jump: ACCEPT_TRUSTED
      comment: ansible_pacemaker_
  when: mssql_fw_rules and iptablesrules.stdout.find("ansible_pacemaker_") == -1
  with_items:
    - destination_port: 2224
      protocol: tcp
    - destination_port: 3121
      protocol: tcp
    - destination_port: 21064
      protocol: tcp
    - destination_port: 5405
      protocol: udp
  notify: save iptables

- name: Stop any existing mssql-server
  service:
        name: mssql-server
        state: stopped

- name: Run mssql setup script
  shell:  MSSQL_PID='{{edition}}' MSSQL_SA_PASSWORD='{{db_password}}' /opt/mssql/bin/mssql-conf -n setup accept-eula
  register: setup_output
  failed_when: "'Setup has completed successfully. SQL Server is now starting.' not in setup_output.stdout"

- name: Start and enable mssql-server service
  service:
      name: mssql-server
      enabled: yes
      state: started